{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postPaymentLinksPaymentLink
module StripeAPI.Operations.PostPaymentLinksPaymentLink where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/payment_links/{payment_link}
--
-- \<p>Updates a payment link.\<\/p>
postPaymentLinksPaymentLink ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | payment_link | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostPaymentLinksPaymentLinkResponse)
postPaymentLinksPaymentLink
  paymentLink
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostPaymentLinksPaymentLinkResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostPaymentLinksPaymentLinkResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              PaymentLink
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostPaymentLinksPaymentLinkResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/payment_links/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel paymentLink)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostPaymentLinksPaymentLinkRequestBody = PostPaymentLinksPaymentLinkRequestBody
  { -- | active: Whether the payment link\'s \`url\` is active. If \`false\`, customers visiting the URL will be shown a page saying that the link has been deactivated.
    postPaymentLinksPaymentLinkRequestBodyActive :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | after_completion: Behavior after the purchase is complete.
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'),
    -- | allow_promotion_codes: Enables user redeemable promotion codes.
    postPaymentLinksPaymentLinkRequestBodyAllowPromotionCodes :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | automatic_tax: Configuration for automatic tax collection.
    postPaymentLinksPaymentLinkRequestBodyAutomaticTax :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyAutomaticTax'),
    -- | billing_address_collection: Configuration for collecting the customer\'s billing address.
    postPaymentLinksPaymentLinkRequestBodyBillingAddressCollection :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'),
    -- | customer_creation: Configures whether [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link create a [Customer](https:\/\/stripe.com\/docs\/api\/customers).
    postPaymentLinksPaymentLinkRequestBodyCustomerCreation :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'),
    -- | expand: Specifies which fields in the response should be expanded.
    postPaymentLinksPaymentLinkRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | line_items: The line items representing what is being sold. Each line item represents an item being sold. Up to 20 line items are supported.
    postPaymentLinksPaymentLinkRequestBodyLineItems :: (GHC.Maybe.Maybe ([PostPaymentLinksPaymentLinkRequestBodyLineItems'])),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`. Metadata associated with this Payment Link will automatically be copied to [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link.
    postPaymentLinksPaymentLinkRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | payment_method_types: The list of payment method types that customers can use. Pass an empty string to enable automatic payment methods that use your [payment method settings](https:\/\/dashboard.stripe.com\/settings\/payment_methods).
    postPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'Variants),
    -- | shipping_address_collection: Configuration for collecting the customer\'s shipping address.
    postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("active" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyActive obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("after_completion" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allow_promotion_codes" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAllowPromotionCodes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyBillingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_creation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyCustomerCreation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("active" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyActive obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("after_completion" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allow_promotion_codes" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAllowPromotionCodes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyBillingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_creation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyCustomerCreation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBody" (\obj -> ((((((((((GHC.Base.pure PostPaymentLinksPaymentLinkRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "active")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "after_completion")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allow_promotion_codes")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "automatic_tax")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "billing_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer_creation")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line_items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_address_collection"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBody' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBody :: PostPaymentLinksPaymentLinkRequestBody
mkPostPaymentLinksPaymentLinkRequestBody =
  PostPaymentLinksPaymentLinkRequestBody
    { postPaymentLinksPaymentLinkRequestBodyActive = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyAfterCompletion = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyAllowPromotionCodes = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyAutomaticTax = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyBillingAddressCollection = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyCustomerCreation = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyExpand = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyLineItems = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyMetadata = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion@ in the specification.
--
-- Behavior after the purchase is complete.
data PostPaymentLinksPaymentLinkRequestBodyAfterCompletion' = PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'
  { -- | hosted_confirmation
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'),
    -- | redirect
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'),
    -- | type
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type :: PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_confirmation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("redirect" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect obj) : ["type" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_confirmation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("redirect" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect obj) : ["type" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'" (\obj -> ((GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyAfterCompletion' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "hosted_confirmation")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "redirect")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion' ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'
  PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type' ->
  PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion' postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type =
  PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'
    { postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type = postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.hosted_confirmation@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' = PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'
  { -- | custom_message
    --
    -- Constraints:
    --
    -- * Maximum length of 500
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'CustomMessage :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_message" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'CustomMessage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_message" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'CustomMessage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'" (\obj -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "custom_message"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' :: PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' = PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation' {postPaymentLinksPaymentLinkRequestBodyAfterCompletion'HostedConfirmation'CustomMessage = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.redirect@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' = PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'
  { -- | url
    --
    -- Constraints:
    --
    -- * Maximum length of 2048
    postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["url" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["url" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'" (\obj -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url'
  Data.Text.Internal.Text ->
  PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'
mkPostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url = PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect' {postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url = postPaymentLinksPaymentLinkRequestBodyAfterCompletion'Redirect'Url}

-- | Defines the enum schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.type@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"hosted_confirmation"@
    PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumHostedConfirmation
  | -- | Represents the JSON value @"redirect"@
    PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumRedirect
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type' where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'Other val) = val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumHostedConfirmation) = "hosted_confirmation"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumRedirect) = "redirect"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "hosted_confirmation" -> PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumHostedConfirmation
            | val GHC.Classes.== "redirect" -> PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'EnumRedirect
            | GHC.Base.otherwise -> PostPaymentLinksPaymentLinkRequestBodyAfterCompletion'Type'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.automatic_tax@ in the specification.
--
-- Configuration for automatic tax collection.
data PostPaymentLinksPaymentLinkRequestBodyAutomaticTax' = PostPaymentLinksPaymentLinkRequestBodyAutomaticTax'
  { -- | enabled
    postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyAutomaticTax' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyAutomaticTax' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyAutomaticTax'" (\obj -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyAutomaticTax' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyAutomaticTax'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyAutomaticTax' ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksPaymentLinkRequestBodyAutomaticTax'
mkPostPaymentLinksPaymentLinkRequestBodyAutomaticTax' postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled = PostPaymentLinksPaymentLinkRequestBodyAutomaticTax' {postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled = postPaymentLinksPaymentLinkRequestBodyAutomaticTax'Enabled}

-- | Defines the enum schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_address_collection@ in the specification.
--
-- Configuration for collecting the customer\'s billing address.
data PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumAuto
  | -- | Represents the JSON value @"required"@
    PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection' where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'Other val) = val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumAuto) = "auto"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumRequired) = "required"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumAuto
            | val GHC.Classes.== "required" -> PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'EnumRequired
            | GHC.Base.otherwise -> PostPaymentLinksPaymentLinkRequestBodyBillingAddressCollection'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_creation@ in the specification.
--
-- Configures whether [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link create a [Customer](https:\/\/stripe.com\/docs\/api\/customers).
data PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always"@
    PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumAlways
  | -- | Represents the JSON value @"if_required"@
    PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumIfRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyCustomerCreation' where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'Other val) = val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumAlways) = "always"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumIfRequired) = "if_required"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyCustomerCreation' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always" -> PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumAlways
            | val GHC.Classes.== "if_required" -> PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'EnumIfRequired
            | GHC.Base.otherwise -> PostPaymentLinksPaymentLinkRequestBodyCustomerCreation'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyLineItems' = PostPaymentLinksPaymentLinkRequestBodyLineItems'
  { -- | adjustable_quantity
    postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity :: (GHC.Maybe.Maybe PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'),
    -- | id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postPaymentLinksPaymentLinkRequestBodyLineItems'Id :: Data.Text.Internal.Text,
    -- | quantity
    postPaymentLinksPaymentLinkRequestBodyLineItems'Quantity :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyLineItems' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("adjustable_quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity obj) : ["id" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyLineItems'Id obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'Quantity obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("adjustable_quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity obj) : ["id" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyLineItems'Id obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'Quantity obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyLineItems' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyLineItems'" (\obj -> ((GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyLineItems' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "adjustable_quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "quantity"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyLineItems'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyLineItems' ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyLineItems'Id'
  Data.Text.Internal.Text ->
  PostPaymentLinksPaymentLinkRequestBodyLineItems'
mkPostPaymentLinksPaymentLinkRequestBodyLineItems' postPaymentLinksPaymentLinkRequestBodyLineItems'Id =
  PostPaymentLinksPaymentLinkRequestBodyLineItems'
    { postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyLineItems'Id = postPaymentLinksPaymentLinkRequestBodyLineItems'Id,
      postPaymentLinksPaymentLinkRequestBodyLineItems'Quantity = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.adjustable_quantity@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' = PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'
  { -- | enabled
    postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled :: GHC.Types.Bool,
    -- | maximum
    postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Maximum :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | minimum
    postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Minimum :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Minimum obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Minimum obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'" (\obj -> ((GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "maximum")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "minimum"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'
mkPostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity' postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled =
  PostPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'
    { postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled = postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Enabled,
      postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Maximum = GHC.Maybe.Nothing,
      postPaymentLinksPaymentLinkRequestBodyLineItems'AdjustableQuantity'Minimum = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_types.anyOf.items@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"card"@
    PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1EnumCard
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1 where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1Other val) = val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1EnumCard) = "card"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1 where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "card" -> PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1EnumCard
            | GHC.Base.otherwise -> PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_types.anyOf@ in the specification.
--
-- The list of payment method types that customers can use. Pass an empty string to enable automatic payment methods that use your [payment method settings](https:\/\/dashboard.stripe.com\/settings\/payment_methods).
data PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'Variants
  = -- | Represents the JSON value @""@
    PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'EmptyString
  | PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'ListTPostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1 ([PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'Variants where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'ListTPostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'EmptyString
        | GHC.Base.otherwise -> case (PostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'ListTPostPaymentLinksPaymentLinkRequestBodyPaymentMethodTypes'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection.anyOf@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 = PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1
  { -- | allowed_countries
    postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries :: ([PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1" (\obj -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allowed_countries"))

-- | Create a new 'PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1' with all required fields.
mkPostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 ::
  -- | 'postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'
  [PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'] ->
  PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1
mkPostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries = PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 {postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries = postPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries}

-- | Defines the enum schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection.anyOf.properties.allowed_countries.items@ in the specification.
data PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries' where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'Other val) = val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAC) = "AC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAD) = "AD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAE) = "AE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAF) = "AF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAG) = "AG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAI) = "AI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAL) = "AL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAM) = "AM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAO) = "AO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAQ) = "AQ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAR) = "AR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAT) = "AT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAU) = "AU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAW) = "AW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAX) = "AX"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAZ) = "AZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBA) = "BA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBB) = "BB"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBD) = "BD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBE) = "BE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBF) = "BF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBG) = "BG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBH) = "BH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBI) = "BI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBJ) = "BJ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBL) = "BL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBM) = "BM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBN) = "BN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBO) = "BO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBQ) = "BQ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBR) = "BR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBS) = "BS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBT) = "BT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBV) = "BV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBW) = "BW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBY) = "BY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBZ) = "BZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCA) = "CA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCD) = "CD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCF) = "CF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCG) = "CG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCH) = "CH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCI) = "CI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCK) = "CK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCL) = "CL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCM) = "CM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCN) = "CN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCO) = "CO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCR) = "CR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCV) = "CV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCW) = "CW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCY) = "CY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCZ) = "CZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDE) = "DE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDJ) = "DJ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDK) = "DK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDM) = "DM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDO) = "DO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDZ) = "DZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEC) = "EC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEE) = "EE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEG) = "EG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEH) = "EH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumER) = "ER"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumES) = "ES"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumET) = "ET"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFI) = "FI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFJ) = "FJ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFK) = "FK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFO) = "FO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFR) = "FR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGA) = "GA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGB) = "GB"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGD) = "GD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGE) = "GE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGF) = "GF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGG) = "GG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGH) = "GH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGI) = "GI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGL) = "GL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGM) = "GM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGN) = "GN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGP) = "GP"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGQ) = "GQ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGR) = "GR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGS) = "GS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGT) = "GT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGU) = "GU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGW) = "GW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGY) = "GY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHK) = "HK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHN) = "HN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHR) = "HR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHT) = "HT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHU) = "HU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumID) = "ID"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIE) = "IE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIL) = "IL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIM) = "IM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIN) = "IN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIO) = "IO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIQ) = "IQ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIS) = "IS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIT) = "IT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJE) = "JE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJM) = "JM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJO) = "JO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJP) = "JP"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKE) = "KE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKG) = "KG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKH) = "KH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKI) = "KI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKM) = "KM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKN) = "KN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKR) = "KR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKW) = "KW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKY) = "KY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKZ) = "KZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLA) = "LA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLB) = "LB"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLC) = "LC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLI) = "LI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLK) = "LK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLR) = "LR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLS) = "LS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLT) = "LT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLU) = "LU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLV) = "LV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLY) = "LY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMA) = "MA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMC) = "MC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMD) = "MD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumME) = "ME"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMF) = "MF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMG) = "MG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMK) = "MK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumML) = "ML"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMM) = "MM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMN) = "MN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMO) = "MO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMQ) = "MQ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMR) = "MR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMS) = "MS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMT) = "MT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMU) = "MU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMV) = "MV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMW) = "MW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMX) = "MX"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMY) = "MY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMZ) = "MZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNA) = "NA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNC) = "NC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNE) = "NE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNG) = "NG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNI) = "NI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNL) = "NL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNO) = "NO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNP) = "NP"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNR) = "NR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNU) = "NU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNZ) = "NZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumOM) = "OM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPA) = "PA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPE) = "PE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPF) = "PF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPG) = "PG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPH) = "PH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPK) = "PK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPL) = "PL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPM) = "PM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPN) = "PN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPR) = "PR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPS) = "PS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPT) = "PT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPY) = "PY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumQA) = "QA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRE) = "RE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRO) = "RO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRS) = "RS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRU) = "RU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRW) = "RW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSA) = "SA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSB) = "SB"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSC) = "SC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSE) = "SE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSG) = "SG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSH) = "SH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSI) = "SI"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSJ) = "SJ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSK) = "SK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSL) = "SL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSM) = "SM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSN) = "SN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSO) = "SO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSR) = "SR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSS) = "SS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumST) = "ST"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSV) = "SV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSX) = "SX"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSZ) = "SZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTA) = "TA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTC) = "TC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTD) = "TD"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTF) = "TF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTG) = "TG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTH) = "TH"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTJ) = "TJ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTK) = "TK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTL) = "TL"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTM) = "TM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTN) = "TN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTO) = "TO"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTR) = "TR"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTT) = "TT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTV) = "TV"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTW) = "TW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTZ) = "TZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUA) = "UA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUG) = "UG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUS) = "US"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUY) = "UY"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUZ) = "UZ"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVA) = "VA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVC) = "VC"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVE) = "VE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVG) = "VG"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVN) = "VN"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVU) = "VU"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWF) = "WF"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWS) = "WS"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumXK) = "XK"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYE) = "YE"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYT) = "YT"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZA) = "ZA"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZM) = "ZM"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZW) = "ZW"
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1AllowedCountries'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/payment_links\/{payment_link}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection.anyOf@ in the specification.
--
-- Configuration for collecting the customer\'s shipping address.
data PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'Variants
  = -- | Represents the JSON value @""@
    PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'EmptyString
  | PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'Variants where
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'EmptyString
        | GHC.Base.otherwise -> case (PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'PostPaymentLinksPaymentLinkRequestBodyShippingAddressCollection'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'postPaymentLinksPaymentLink'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostPaymentLinksPaymentLinkResponseError' is used.
data PostPaymentLinksPaymentLinkResponse
  = -- | Means either no matching case available or a parse error
    PostPaymentLinksPaymentLinkResponseError GHC.Base.String
  | -- | Successful response.
    PostPaymentLinksPaymentLinkResponse200 PaymentLink
  | -- | Error response.
    PostPaymentLinksPaymentLinkResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
