{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTestHelpersTreasuryOutboundPaymentsIdReturn
module StripeAPI.Operations.PostTestHelpersTreasuryOutboundPaymentsIdReturn where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/test_helpers/treasury/outbound_payments/{id}/return
--
-- \<p>Transitions a test mode created OutboundPayment to the \<code>returned\<\/code> status. The OutboundPayment must already be in the \<code>processing\<\/code> state.\<\/p>
postTestHelpersTreasuryOutboundPaymentsIdReturn ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | id | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostTestHelpersTreasuryOutboundPaymentsIdReturnResponse)
postTestHelpersTreasuryOutboundPaymentsIdReturn
  id
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostTestHelpersTreasuryOutboundPaymentsIdReturnResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTestHelpersTreasuryOutboundPaymentsIdReturnResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Treasury'outboundPayment
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTestHelpersTreasuryOutboundPaymentsIdReturnResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/test_helpers/treasury/outbound_payments/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel id)) GHC.Base.++ "/return"))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_payments\/{id}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody = PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody
  { -- | expand: Specifies which fields in the response should be expanded.
    postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | returned_details: Optional hash to set the the return code.
    postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails :: (GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("returned_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("returned_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody" (\obj -> (GHC.Base.pure PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "returned_details"))

-- | Create a new 'PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody' with all required fields.
mkPostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody :: PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody
mkPostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody =
  PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBody
    { postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyExpand = GHC.Maybe.Nothing,
      postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_payments\/{id}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.returned_details@ in the specification.
--
-- Optional hash to set the the return code.
data PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' = PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'
  { -- | code
    postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code :: (GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'" (\obj -> GHC.Base.pure PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "code"))

-- | Create a new 'PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'' with all required fields.
mkPostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' :: PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'
mkPostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' = PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails' {postTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_payments\/{id}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.returned_details.properties.code@ in the specification.
data PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"account_closed"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountClosed
  | -- | Represents the JSON value @"account_frozen"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen
  | -- | Represents the JSON value @"bank_account_restricted"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted
  | -- | Represents the JSON value @"bank_ownership_changed"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged
  | -- | Represents the JSON value @"declined"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumDeclined
  | -- | Represents the JSON value @"incorrect_account_holder_name"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName
  | -- | Represents the JSON value @"invalid_account_number"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber
  | -- | Represents the JSON value @"invalid_currency"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency
  | -- | Represents the JSON value @"no_account"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumNoAccount
  | -- | Represents the JSON value @"other"@
    PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumOther
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code' where
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'Other val) = val
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountClosed) = "account_closed"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen) = "account_frozen"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted) = "bank_account_restricted"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged) = "bank_ownership_changed"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumDeclined) = "declined"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName) = "incorrect_account_holder_name"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber) = "invalid_account_number"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency) = "invalid_currency"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumNoAccount) = "no_account"
  toJSON (PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumOther) = "other"

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "account_closed" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountClosed
            | val GHC.Classes.== "account_frozen" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen
            | val GHC.Classes.== "bank_account_restricted" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted
            | val GHC.Classes.== "bank_ownership_changed" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged
            | val GHC.Classes.== "declined" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumDeclined
            | val GHC.Classes.== "incorrect_account_holder_name" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName
            | val GHC.Classes.== "invalid_account_number" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber
            | val GHC.Classes.== "invalid_currency" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency
            | val GHC.Classes.== "no_account" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumNoAccount
            | val GHC.Classes.== "other" -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'EnumOther
            | GHC.Base.otherwise -> PostTestHelpersTreasuryOutboundPaymentsIdReturnRequestBodyReturnedDetails'Code'Other val
      )

-- | Represents a response of the operation 'postTestHelpersTreasuryOutboundPaymentsIdReturn'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTestHelpersTreasuryOutboundPaymentsIdReturnResponseError' is used.
data PostTestHelpersTreasuryOutboundPaymentsIdReturnResponse
  = -- | Means either no matching case available or a parse error
    PostTestHelpersTreasuryOutboundPaymentsIdReturnResponseError GHC.Base.String
  | -- | Successful response.
    PostTestHelpersTreasuryOutboundPaymentsIdReturnResponse200 Treasury'outboundPayment
  | -- | Error response.
    PostTestHelpersTreasuryOutboundPaymentsIdReturnResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
