{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingCardholderSpendingLimit
module StripeAPI.Types.IssuingCardholderSpendingLimit where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_cardholder_spending_limit@ in the specification.
data IssuingCardholderSpendingLimit = IssuingCardholderSpendingLimit
  { -- | amount: Maximum amount allowed to spend per interval. This amount is in the card\'s currency and in the [smallest currency unit](https:\/\/stripe.com\/docs\/currencies\#zero-decimal).
    issuingCardholderSpendingLimitAmount :: GHC.Types.Int,
    -- | categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) this limit applies to. Omitting this field will apply the limit to all categories.
    issuingCardholderSpendingLimitCategories :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ([IssuingCardholderSpendingLimitCategories'NonNullable]))),
    -- | interval: Interval (or event) to which the amount applies.
    issuingCardholderSpendingLimitInterval :: IssuingCardholderSpendingLimitInterval'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderSpendingLimit where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= issuingCardholderSpendingLimitAmount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (issuingCardholderSpendingLimitCategories obj) : ["interval" Data.Aeson.Types.ToJSON..= issuingCardholderSpendingLimitInterval obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= issuingCardholderSpendingLimitAmount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (issuingCardholderSpendingLimitCategories obj) : ["interval" Data.Aeson.Types.ToJSON..= issuingCardholderSpendingLimitInterval obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderSpendingLimit where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardholderSpendingLimit" (\obj -> ((GHC.Base.pure IssuingCardholderSpendingLimit GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval"))

-- | Create a new 'IssuingCardholderSpendingLimit' with all required fields.
mkIssuingCardholderSpendingLimit ::
  -- | 'issuingCardholderSpendingLimitAmount'
  GHC.Types.Int ->
  -- | 'issuingCardholderSpendingLimitInterval'
  IssuingCardholderSpendingLimitInterval' ->
  IssuingCardholderSpendingLimit
mkIssuingCardholderSpendingLimit issuingCardholderSpendingLimitAmount issuingCardholderSpendingLimitInterval =
  IssuingCardholderSpendingLimit
    { issuingCardholderSpendingLimitAmount = issuingCardholderSpendingLimitAmount,
      issuingCardholderSpendingLimitCategories = GHC.Maybe.Nothing,
      issuingCardholderSpendingLimitInterval = issuingCardholderSpendingLimitInterval
    }

-- | Defines the enum schema located at @components.schemas.issuing_cardholder_spending_limit.properties.categories.items@ in the specification.
data IssuingCardholderSpendingLimitCategories'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardholderSpendingLimitCategories'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardholderSpendingLimitCategories'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    IssuingCardholderSpendingLimitCategories'NonNullableEnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderSpendingLimitCategories'NonNullable where
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableOther val) = val
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAdvertisingServices) = "advertising_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAmbulanceServices) = "ambulance_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueReproductions) = "antique_reproductions"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueShops) = "antique_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAquariums) = "aquariums"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoPaintShops) = "auto_paint_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoServiceShops) = "auto_service_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomobileAssociations) = "automobile_associations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBakeries) = "bakeries"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBandsOrchestras) = "bands_orchestras"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBicycleShops) = "bicycle_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatDealers) = "boat_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBookStores) = "book_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBowlingAlleys) = "bowling_alleys"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBusLines) = "bus_lines"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarWashes) = "car_washes"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpentryServices) = "carpentry_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCaterers) = "caterers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumChildCareServices) = "child_care_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropractors) = "chiropractors"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumClothingRental) = "clothing_rental"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCollegesUniversities) = "colleges_universities"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialEquipment) = "commercial_equipment"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialFootwear) = "commercial_footwear"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerNetworkServices) = "computer_network_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerProgramming) = "computer_programming"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerRepair) = "computer_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumConcreteWorkServices) = "concrete_work_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumConstructionMaterials) = "construction_materials"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCosmeticStores) = "cosmetic_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCounselingServices) = "counseling_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCountryClubs) = "country_clubs"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCourierServices) = "courier_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCourtCosts) = "court_costs"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumCruiseLines) = "cruise_lines"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDairyProductsStores) = "dairy_products_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDatingEscortServices) = "dating_escort_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDepartmentStores) = "department_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDetectiveAgencies) = "detective_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDiscountStores) = "discount_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDoctors) = "doctors"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDrinkingPlaces) = "drinking_places"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDryCleaners) = "dry_cleaners"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDurableGoods) = "durable_goods"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumDutyFreeStores) = "duty_free_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumEducationalServices) = "educational_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricRazorStores) = "electric_razor_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalServices) = "electrical_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsStores) = "electronics_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumEquipmentRental) = "equipment_rental"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumExterminatingServices) = "exterminating_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFinancialInstitutions) = "financial_institutions"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFlorists) = "florists"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGeneralServices) = "general_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGovernmentServices) = "government_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareStores) = "hardware_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHospitals) = "hospitals"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumIndustrialSupplies) = "industrial_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceDefault) = "insurance_default"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLandscapingServices) = "landscaping_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundries) = "laundries"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMassageParlors) = "massage_parlors"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalServices) = "medical_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMembershipOrganizations) = "membership_organizations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMetalServiceCenters) = "metal_service_centers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneous) = "miscellaneous"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNondurableGoods) = "nondurable_goods"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumOsteopaths) = "osteopaths"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPassengerRailways) = "passenger_railways"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPawnShops) = "pawn_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotoDeveloping) = "photo_developing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicStudios) = "photographic_studios"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPictureVideoProduction) = "picture_video_production"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPoliticalOrganizations) = "political_organizations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumProfessionalServices) = "professional_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumRailroads) = "railroads"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumRecordStores) = "record_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousOrganizations) = "religious_organizations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumServiceStations) = "service_stations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeStores) = "shoe_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialTradeServices) = "special_trade_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTailorsAlterations) = "tailors_alterations"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationServices) = "telecommunication_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTelegraphServices) = "telegraph_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTestingLaboratories) = "testing_laboratories"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTimeshares) = "timeshares"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTowingServices) = "towing_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTransportationServices) = "transportation_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumTypewriterStores) = "typewriter_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumUtilities) = "utilities"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVarietyStores) = "variety_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVeterinaryServices) = "veterinary_services"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoGameArcades) = "video_game_arcades"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWeldingRepair) = "welding_repair"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWholesaleClubs) = "wholesale_clubs"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (IssuingCardholderSpendingLimitCategories'NonNullableEnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderSpendingLimitCategories'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCountryClubs
            | val GHC.Classes.== "courier_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCourierServices
            | val GHC.Classes.== "court_costs" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDiscountStores
            | val GHC.Classes.== "doctors" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLandscapingServices
            | val GHC.Classes.== "laundries" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumUtilities
            | val GHC.Classes.== "variety_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> IssuingCardholderSpendingLimitCategories'NonNullableEnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> IssuingCardholderSpendingLimitCategories'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.issuing_cardholder_spending_limit.properties.interval@ in the specification.
--
-- Interval (or event) to which the amount applies.
data IssuingCardholderSpendingLimitInterval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardholderSpendingLimitInterval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardholderSpendingLimitInterval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"all_time"@
    IssuingCardholderSpendingLimitInterval'EnumAllTime
  | -- | Represents the JSON value @"daily"@
    IssuingCardholderSpendingLimitInterval'EnumDaily
  | -- | Represents the JSON value @"monthly"@
    IssuingCardholderSpendingLimitInterval'EnumMonthly
  | -- | Represents the JSON value @"per_authorization"@
    IssuingCardholderSpendingLimitInterval'EnumPerAuthorization
  | -- | Represents the JSON value @"weekly"@
    IssuingCardholderSpendingLimitInterval'EnumWeekly
  | -- | Represents the JSON value @"yearly"@
    IssuingCardholderSpendingLimitInterval'EnumYearly
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderSpendingLimitInterval' where
  toJSON (IssuingCardholderSpendingLimitInterval'Other val) = val
  toJSON (IssuingCardholderSpendingLimitInterval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardholderSpendingLimitInterval'EnumAllTime) = "all_time"
  toJSON (IssuingCardholderSpendingLimitInterval'EnumDaily) = "daily"
  toJSON (IssuingCardholderSpendingLimitInterval'EnumMonthly) = "monthly"
  toJSON (IssuingCardholderSpendingLimitInterval'EnumPerAuthorization) = "per_authorization"
  toJSON (IssuingCardholderSpendingLimitInterval'EnumWeekly) = "weekly"
  toJSON (IssuingCardholderSpendingLimitInterval'EnumYearly) = "yearly"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderSpendingLimitInterval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "all_time" -> IssuingCardholderSpendingLimitInterval'EnumAllTime
            | val GHC.Classes.== "daily" -> IssuingCardholderSpendingLimitInterval'EnumDaily
            | val GHC.Classes.== "monthly" -> IssuingCardholderSpendingLimitInterval'EnumMonthly
            | val GHC.Classes.== "per_authorization" -> IssuingCardholderSpendingLimitInterval'EnumPerAuthorization
            | val GHC.Classes.== "weekly" -> IssuingCardholderSpendingLimitInterval'EnumWeekly
            | val GHC.Classes.== "yearly" -> IssuingCardholderSpendingLimitInterval'EnumYearly
            | GHC.Base.otherwise -> IssuingCardholderSpendingLimitInterval'Other val
      )
