{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema OrdersPaymentMethodOptionsAfterpayClearpay
module StripeAPI.Types.OrdersPaymentMethodOptionsAfterpayClearpay where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.orders_payment_method_options_afterpay_clearpay@ in the specification.
data OrdersPaymentMethodOptionsAfterpayClearpay = OrdersPaymentMethodOptionsAfterpayClearpay
  { -- | capture_method: Controls when the funds will be captured from the customer\'s account.
    ordersPaymentMethodOptionsAfterpayClearpayCaptureMethod :: (GHC.Maybe.Maybe OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'),
    -- | reference: Order identifier shown to the user in Afterpay\'s online portal. We recommend using a value that helps you answer any questions a customer might have about the payment. The identifier is limited to 128 characters and may contain only letters, digits, underscores, backslashes and dashes.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    ordersPaymentMethodOptionsAfterpayClearpayReference :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | setup_future_usage: Indicates that you intend to make future payments with the payment method.
    --
    -- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the order\'s Customer, if present, after the order\'s PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
    --
    -- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
    --
    -- If \`setup_future_usage\` is already set and you are performing a request using a publishable key, you may only update the value from \`on_session\` to \`off_session\`.
    ordersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage :: (GHC.Maybe.Maybe OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON OrdersPaymentMethodOptionsAfterpayClearpay where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpayCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpayReference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpayCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpayReference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (ordersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON OrdersPaymentMethodOptionsAfterpayClearpay where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "OrdersPaymentMethodOptionsAfterpayClearpay" (\obj -> ((GHC.Base.pure OrdersPaymentMethodOptionsAfterpayClearpay GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "reference")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'OrdersPaymentMethodOptionsAfterpayClearpay' with all required fields.
mkOrdersPaymentMethodOptionsAfterpayClearpay :: OrdersPaymentMethodOptionsAfterpayClearpay
mkOrdersPaymentMethodOptionsAfterpayClearpay =
  OrdersPaymentMethodOptionsAfterpayClearpay
    { ordersPaymentMethodOptionsAfterpayClearpayCaptureMethod = GHC.Maybe.Nothing,
      ordersPaymentMethodOptionsAfterpayClearpayReference = GHC.Maybe.Nothing,
      ordersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.orders_payment_method_options_afterpay_clearpay.properties.capture_method@ in the specification.
--
-- Controls when the funds will be captured from the customer\'s account.
data OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod' where
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'Other val) = val
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumAutomatic) = "automatic"
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'EnumManual
            | GHC.Base.otherwise -> OrdersPaymentMethodOptionsAfterpayClearpayCaptureMethod'Other val
      )

-- | Defines the enum schema located at @components.schemas.orders_payment_method_options_afterpay_clearpay.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with the payment method.
--
-- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the order\'s Customer, if present, after the order\'s PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
--
-- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
--
-- If \`setup_future_usage\` is already set and you are performing a request using a publishable key, you may only update the value from \`on_session\` to \`off_session\`.
data OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage' where
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'Other val) = val
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> OrdersPaymentMethodOptionsAfterpayClearpaySetupFutureUsage'Other val
      )
