{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentIntentNextActionAlipayHandleRedirect
module StripeAPI.Types.PaymentIntentNextActionAlipayHandleRedirect where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_intent_next_action_alipay_handle_redirect@ in the specification.
data PaymentIntentNextActionAlipayHandleRedirect = PaymentIntentNextActionAlipayHandleRedirect
  { -- | native_data: The native data to be used with Alipay SDK you must redirect your customer to in order to authenticate the payment in an Android App.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionAlipayHandleRedirectNativeData :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | native_url: The native URL you must redirect your customer to in order to authenticate the payment in an iOS App.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionAlipayHandleRedirectNativeUrl :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | return_url: If the customer does not exit their browser while authenticating, they will be redirected to this specified URL after completion.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionAlipayHandleRedirectReturnUrl :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | url: The URL you must redirect your customer to in order to authenticate the payment.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionAlipayHandleRedirectUrl :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentNextActionAlipayHandleRedirect where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("native_data" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectNativeData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("native_url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectNativeUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectUrl obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("native_data" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectNativeData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("native_url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectNativeUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("url" Data.Aeson.Types.ToJSON..=)) (paymentIntentNextActionAlipayHandleRedirectUrl obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentNextActionAlipayHandleRedirect where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentIntentNextActionAlipayHandleRedirect" (\obj -> (((GHC.Base.pure PaymentIntentNextActionAlipayHandleRedirect GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "native_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "native_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "return_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "url"))

-- | Create a new 'PaymentIntentNextActionAlipayHandleRedirect' with all required fields.
mkPaymentIntentNextActionAlipayHandleRedirect :: PaymentIntentNextActionAlipayHandleRedirect
mkPaymentIntentNextActionAlipayHandleRedirect =
  PaymentIntentNextActionAlipayHandleRedirect
    { paymentIntentNextActionAlipayHandleRedirectNativeData = GHC.Maybe.Nothing,
      paymentIntentNextActionAlipayHandleRedirectNativeUrl = GHC.Maybe.Nothing,
      paymentIntentNextActionAlipayHandleRedirectReturnUrl = GHC.Maybe.Nothing,
      paymentIntentNextActionAlipayHandleRedirectUrl = GHC.Maybe.Nothing
    }
