{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentLinksResourcePaymentIntentData
module StripeAPI.Types.PaymentLinksResourcePaymentIntentData where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_links_resource_payment_intent_data@ in the specification.
data PaymentLinksResourcePaymentIntentData = PaymentLinksResourcePaymentIntentData
  { -- | capture_method: Indicates when the funds will be captured from the customer\'s account.
    paymentLinksResourcePaymentIntentDataCaptureMethod :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullable)),
    -- | setup_future_usage: Indicates that you intend to make future payments with the payment method collected during checkout.
    paymentLinksResourcePaymentIntentDataSetupFutureUsage :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinksResourcePaymentIntentData where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentLinksResourcePaymentIntentDataCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentLinksResourcePaymentIntentDataSetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentLinksResourcePaymentIntentDataCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentLinksResourcePaymentIntentDataSetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinksResourcePaymentIntentData where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinksResourcePaymentIntentData" (\obj -> (GHC.Base.pure PaymentLinksResourcePaymentIntentData GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PaymentLinksResourcePaymentIntentData' with all required fields.
mkPaymentLinksResourcePaymentIntentData :: PaymentLinksResourcePaymentIntentData
mkPaymentLinksResourcePaymentIntentData =
  PaymentLinksResourcePaymentIntentData
    { paymentLinksResourcePaymentIntentDataCaptureMethod = GHC.Maybe.Nothing,
      paymentLinksResourcePaymentIntentDataSetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_links_resource_payment_intent_data.properties.capture_method@ in the specification.
--
-- Indicates when the funds will be captured from the customer\'s account.
data PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullable where
  toJSON (PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableOther val) = val
  toJSON (PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumAutomatic) = "automatic"
  toJSON (PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumAutomatic
            | val GHC.Classes.== "manual" -> PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableEnumManual
            | GHC.Base.otherwise -> PaymentLinksResourcePaymentIntentDataCaptureMethod'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.payment_links_resource_payment_intent_data.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with the payment method collected during checkout.
data PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"off_session"@
    PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullable where
  toJSON (PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableOther val) = val
  toJSON (PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOffSession) = "off_session"
  toJSON (PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "off_session" -> PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOffSession
            | val GHC.Classes.== "on_session" -> PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableEnumOnSession
            | GHC.Base.otherwise -> PaymentLinksResourcePaymentIntentDataSetupFutureUsage'NonNullableOther val
      )
