{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema ShippingRateDeliveryEstimateBound
module StripeAPI.Types.ShippingRateDeliveryEstimateBound where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.shipping_rate_delivery_estimate_bound@ in the specification.
data ShippingRateDeliveryEstimateBound = ShippingRateDeliveryEstimateBound
  { -- | unit: A unit of time.
    shippingRateDeliveryEstimateBoundUnit :: ShippingRateDeliveryEstimateBoundUnit',
    -- | value: Must be greater than 0.
    shippingRateDeliveryEstimateBoundValue :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateBound where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= shippingRateDeliveryEstimateBoundUnit obj] : ["value" Data.Aeson.Types.ToJSON..= shippingRateDeliveryEstimateBoundValue obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= shippingRateDeliveryEstimateBoundUnit obj] : ["value" Data.Aeson.Types.ToJSON..= shippingRateDeliveryEstimateBoundValue obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateBound where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ShippingRateDeliveryEstimateBound" (\obj -> (GHC.Base.pure ShippingRateDeliveryEstimateBound GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "unit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "value"))

-- | Create a new 'ShippingRateDeliveryEstimateBound' with all required fields.
mkShippingRateDeliveryEstimateBound ::
  -- | 'shippingRateDeliveryEstimateBoundUnit'
  ShippingRateDeliveryEstimateBoundUnit' ->
  -- | 'shippingRateDeliveryEstimateBoundValue'
  GHC.Types.Int ->
  ShippingRateDeliveryEstimateBound
mkShippingRateDeliveryEstimateBound shippingRateDeliveryEstimateBoundUnit shippingRateDeliveryEstimateBoundValue =
  ShippingRateDeliveryEstimateBound
    { shippingRateDeliveryEstimateBoundUnit = shippingRateDeliveryEstimateBoundUnit,
      shippingRateDeliveryEstimateBoundValue = shippingRateDeliveryEstimateBoundValue
    }

-- | Defines the enum schema located at @components.schemas.shipping_rate_delivery_estimate_bound.properties.unit@ in the specification.
--
-- A unit of time.
data ShippingRateDeliveryEstimateBoundUnit'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    ShippingRateDeliveryEstimateBoundUnit'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    ShippingRateDeliveryEstimateBoundUnit'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business_day"@
    ShippingRateDeliveryEstimateBoundUnit'EnumBusinessDay
  | -- | Represents the JSON value @"day"@
    ShippingRateDeliveryEstimateBoundUnit'EnumDay
  | -- | Represents the JSON value @"hour"@
    ShippingRateDeliveryEstimateBoundUnit'EnumHour
  | -- | Represents the JSON value @"month"@
    ShippingRateDeliveryEstimateBoundUnit'EnumMonth
  | -- | Represents the JSON value @"week"@
    ShippingRateDeliveryEstimateBoundUnit'EnumWeek
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateBoundUnit' where
  toJSON (ShippingRateDeliveryEstimateBoundUnit'Other val) = val
  toJSON (ShippingRateDeliveryEstimateBoundUnit'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (ShippingRateDeliveryEstimateBoundUnit'EnumBusinessDay) = "business_day"
  toJSON (ShippingRateDeliveryEstimateBoundUnit'EnumDay) = "day"
  toJSON (ShippingRateDeliveryEstimateBoundUnit'EnumHour) = "hour"
  toJSON (ShippingRateDeliveryEstimateBoundUnit'EnumMonth) = "month"
  toJSON (ShippingRateDeliveryEstimateBoundUnit'EnumWeek) = "week"

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateBoundUnit' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business_day" -> ShippingRateDeliveryEstimateBoundUnit'EnumBusinessDay
            | val GHC.Classes.== "day" -> ShippingRateDeliveryEstimateBoundUnit'EnumDay
            | val GHC.Classes.== "hour" -> ShippingRateDeliveryEstimateBoundUnit'EnumHour
            | val GHC.Classes.== "month" -> ShippingRateDeliveryEstimateBoundUnit'EnumMonth
            | val GHC.Classes.== "week" -> ShippingRateDeliveryEstimateBoundUnit'EnumWeek
            | GHC.Base.otherwise -> ShippingRateDeliveryEstimateBoundUnit'Other val
      )
