{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema SourceTransactionSepaCreditTransferData
module StripeAPI.Types.SourceTransactionSepaCreditTransferData where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.source_transaction_sepa_credit_transfer_data@ in the specification.
data SourceTransactionSepaCreditTransferData = SourceTransactionSepaCreditTransferData
  { -- | reference: Reference associated with the transfer.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceTransactionSepaCreditTransferDataReference :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | sender_iban: Sender\'s bank account IBAN.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceTransactionSepaCreditTransferDataSenderIban :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | sender_name: Sender\'s name.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceTransactionSepaCreditTransferDataSenderName :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON SourceTransactionSepaCreditTransferData where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataReference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sender_iban" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataSenderIban obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sender_name" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataSenderName obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataReference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sender_iban" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataSenderIban obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sender_name" Data.Aeson.Types.ToJSON..=)) (sourceTransactionSepaCreditTransferDataSenderName obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON SourceTransactionSepaCreditTransferData where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "SourceTransactionSepaCreditTransferData" (\obj -> ((GHC.Base.pure SourceTransactionSepaCreditTransferData GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "reference")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sender_iban")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sender_name"))

-- | Create a new 'SourceTransactionSepaCreditTransferData' with all required fields.
mkSourceTransactionSepaCreditTransferData :: SourceTransactionSepaCreditTransferData
mkSourceTransactionSepaCreditTransferData =
  SourceTransactionSepaCreditTransferData
    { sourceTransactionSepaCreditTransferDataReference = GHC.Maybe.Nothing,
      sourceTransactionSepaCreditTransferDataSenderIban = GHC.Maybe.Nothing,
      sourceTransactionSepaCreditTransferDataSenderName = GHC.Maybe.Nothing
    }
