{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postIssuingCardholders
module StripeAPI.Operations.PostIssuingCardholders where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/issuing/cardholders
--
-- \<p>Creates a new Issuing \<code>Cardholder\<\/code> object that can be issued cards.\<\/p>
postIssuingCardholders ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  PostIssuingCardholdersRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostIssuingCardholdersResponse)
postIssuingCardholders body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostIssuingCardholdersResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostIssuingCardholdersResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Issuing'cardholder
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostIssuingCardholdersResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/issuing/cardholders") GHC.Base.mempty (GHC.Maybe.Just body) StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostIssuingCardholdersRequestBody = PostIssuingCardholdersRequestBody
  { -- | billing: The cardholder\'s billing address.
    postIssuingCardholdersRequestBodyBilling :: PostIssuingCardholdersRequestBodyBilling',
    -- | company: Additional information about a \`company\` cardholder.
    postIssuingCardholdersRequestBodyCompany :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyCompany'),
    -- | email: The cardholder\'s email address.
    postIssuingCardholdersRequestBodyEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | expand: Specifies which fields in the response should be expanded.
    postIssuingCardholdersRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | individual: Additional information about an \`individual\` cardholder.
    postIssuingCardholdersRequestBodyIndividual :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyIndividual'),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postIssuingCardholdersRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | name: The cardholder\'s name. This will be printed on cards issued to them. The maximum length of this field is 24 characters.
    postIssuingCardholdersRequestBodyName :: Data.Text.Internal.Text,
    -- | phone_number: The cardholder\'s phone number. This will be transformed to [E.164](https:\/\/en.wikipedia.org\/wiki\/E.164) if it is not provided in that format already. This is required for all cardholders who will be creating EU cards. See the [3D Secure documentation](https:\/\/stripe.com\/docs\/issuing\/3d-secure\#when-is-3d-secure-applied) for more details.
    postIssuingCardholdersRequestBodyPhoneNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | spending_controls: Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    postIssuingCardholdersRequestBodySpendingControls :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodySpendingControls'),
    -- | status: Specifies whether to permit authorizations on this cardholder\'s cards. Defaults to \`active\`.
    postIssuingCardholdersRequestBodyStatus :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyStatus'),
    -- | type: One of \`individual\` or \`company\`.
    postIssuingCardholdersRequestBodyType :: PostIssuingCardholdersRequestBodyType'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["billing" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("company" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyCompany obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyEmail obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("individual" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyMetadata obj) : ["name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyPhoneNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyStatus obj) : ["type" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyType obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["billing" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("company" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyCompany obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyEmail obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("individual" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyMetadata obj) : ["name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyPhoneNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyStatus obj) : ["type" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyType obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBody" (\obj -> ((((((((((GHC.Base.pure PostIssuingCardholdersRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "billing")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "company")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "individual")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostIssuingCardholdersRequestBody' with all required fields.
mkPostIssuingCardholdersRequestBody ::
  -- | 'postIssuingCardholdersRequestBodyBilling'
  PostIssuingCardholdersRequestBodyBilling' ->
  -- | 'postIssuingCardholdersRequestBodyName'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersRequestBodyType'
  PostIssuingCardholdersRequestBodyType' ->
  PostIssuingCardholdersRequestBody
mkPostIssuingCardholdersRequestBody postIssuingCardholdersRequestBodyBilling postIssuingCardholdersRequestBodyName postIssuingCardholdersRequestBodyType =
  PostIssuingCardholdersRequestBody
    { postIssuingCardholdersRequestBodyBilling = postIssuingCardholdersRequestBodyBilling,
      postIssuingCardholdersRequestBodyCompany = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyEmail = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyExpand = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyIndividual = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyMetadata = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyName = postIssuingCardholdersRequestBodyName,
      postIssuingCardholdersRequestBodyPhoneNumber = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodySpendingControls = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyStatus = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyType = postIssuingCardholdersRequestBodyType
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing@ in the specification.
--
-- The cardholder\'s billing address.
data PostIssuingCardholdersRequestBodyBilling' = PostIssuingCardholdersRequestBodyBilling'
  { -- | address
    postIssuingCardholdersRequestBodyBilling'Address :: PostIssuingCardholdersRequestBodyBilling'Address'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyBilling' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyBilling' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyBilling'" (\obj -> GHC.Base.pure PostIssuingCardholdersRequestBodyBilling' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address"))

-- | Create a new 'PostIssuingCardholdersRequestBodyBilling'' with all required fields.
mkPostIssuingCardholdersRequestBodyBilling' ::
  -- | 'postIssuingCardholdersRequestBodyBilling'Address'
  PostIssuingCardholdersRequestBodyBilling'Address' ->
  PostIssuingCardholdersRequestBodyBilling'
mkPostIssuingCardholdersRequestBodyBilling' postIssuingCardholdersRequestBodyBilling'Address = PostIssuingCardholdersRequestBodyBilling' {postIssuingCardholdersRequestBodyBilling'Address = postIssuingCardholdersRequestBodyBilling'Address}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing.properties.address@ in the specification.
data PostIssuingCardholdersRequestBodyBilling'Address' = PostIssuingCardholdersRequestBodyBilling'Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'City :: Data.Text.Internal.Text,
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'Country :: Data.Text.Internal.Text,
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'Line1 :: Data.Text.Internal.Text,
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'PostalCode :: Data.Text.Internal.Text,
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyBilling'Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyBilling'Address' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["city" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'City obj] : ["country" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'Country obj] : ["line1" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'Line1 obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyBilling'Address'Line2 obj) : ["postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'PostalCode obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyBilling'Address'State obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["city" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'City obj] : ["country" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'Country obj] : ["line1" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'Line1 obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyBilling'Address'Line2 obj) : ["postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyBilling'Address'PostalCode obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyBilling'Address'State obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyBilling'Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyBilling'Address'" (\obj -> (((((GHC.Base.pure PostIssuingCardholdersRequestBodyBilling'Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "state"))

-- | Create a new 'PostIssuingCardholdersRequestBodyBilling'Address'' with all required fields.
mkPostIssuingCardholdersRequestBodyBilling'Address' ::
  -- | 'postIssuingCardholdersRequestBodyBilling'Address'City'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersRequestBodyBilling'Address'Country'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersRequestBodyBilling'Address'Line1'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersRequestBodyBilling'Address'PostalCode'
  Data.Text.Internal.Text ->
  PostIssuingCardholdersRequestBodyBilling'Address'
mkPostIssuingCardholdersRequestBodyBilling'Address' postIssuingCardholdersRequestBodyBilling'Address'City postIssuingCardholdersRequestBodyBilling'Address'Country postIssuingCardholdersRequestBodyBilling'Address'Line1 postIssuingCardholdersRequestBodyBilling'Address'PostalCode =
  PostIssuingCardholdersRequestBodyBilling'Address'
    { postIssuingCardholdersRequestBodyBilling'Address'City = postIssuingCardholdersRequestBodyBilling'Address'City,
      postIssuingCardholdersRequestBodyBilling'Address'Country = postIssuingCardholdersRequestBodyBilling'Address'Country,
      postIssuingCardholdersRequestBodyBilling'Address'Line1 = postIssuingCardholdersRequestBodyBilling'Address'Line1,
      postIssuingCardholdersRequestBodyBilling'Address'Line2 = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyBilling'Address'PostalCode = postIssuingCardholdersRequestBodyBilling'Address'PostalCode,
      postIssuingCardholdersRequestBodyBilling'Address'State = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.company@ in the specification.
--
-- Additional information about a \`company\` cardholder.
data PostIssuingCardholdersRequestBodyCompany' = PostIssuingCardholdersRequestBodyCompany'
  { -- | tax_id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyCompany'TaxId :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyCompany' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyCompany'TaxId obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyCompany'TaxId obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyCompany' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyCompany'" (\obj -> GHC.Base.pure PostIssuingCardholdersRequestBodyCompany' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_id"))

-- | Create a new 'PostIssuingCardholdersRequestBodyCompany'' with all required fields.
mkPostIssuingCardholdersRequestBodyCompany' :: PostIssuingCardholdersRequestBodyCompany'
mkPostIssuingCardholdersRequestBodyCompany' = PostIssuingCardholdersRequestBodyCompany' {postIssuingCardholdersRequestBodyCompany'TaxId = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual@ in the specification.
--
-- Additional information about an \`individual\` cardholder.
data PostIssuingCardholdersRequestBodyIndividual' = PostIssuingCardholdersRequestBodyIndividual'
  { -- | dob
    postIssuingCardholdersRequestBodyIndividual'Dob :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyIndividual'Dob'),
    -- | first_name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyIndividual'FirstName :: Data.Text.Internal.Text,
    -- | last_name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyIndividual'LastName :: Data.Text.Internal.Text,
    -- | verification
    postIssuingCardholdersRequestBodyIndividual'Verification :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyIndividual'Verification')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyIndividual' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Dob obj) : ["first_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'FirstName obj] : ["last_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'LastName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Dob obj) : ["first_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'FirstName obj] : ["last_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'LastName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyIndividual' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyIndividual'" (\obj -> (((GHC.Base.pure PostIssuingCardholdersRequestBodyIndividual' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "dob")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "first_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "last_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification"))

-- | Create a new 'PostIssuingCardholdersRequestBodyIndividual'' with all required fields.
mkPostIssuingCardholdersRequestBodyIndividual' ::
  -- | 'postIssuingCardholdersRequestBodyIndividual'FirstName'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersRequestBodyIndividual'LastName'
  Data.Text.Internal.Text ->
  PostIssuingCardholdersRequestBodyIndividual'
mkPostIssuingCardholdersRequestBodyIndividual' postIssuingCardholdersRequestBodyIndividual'FirstName postIssuingCardholdersRequestBodyIndividual'LastName =
  PostIssuingCardholdersRequestBodyIndividual'
    { postIssuingCardholdersRequestBodyIndividual'Dob = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyIndividual'FirstName = postIssuingCardholdersRequestBodyIndividual'FirstName,
      postIssuingCardholdersRequestBodyIndividual'LastName = postIssuingCardholdersRequestBodyIndividual'LastName,
      postIssuingCardholdersRequestBodyIndividual'Verification = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.dob@ in the specification.
data PostIssuingCardholdersRequestBodyIndividual'Dob' = PostIssuingCardholdersRequestBodyIndividual'Dob'
  { -- | day
    postIssuingCardholdersRequestBodyIndividual'Dob'Day :: GHC.Types.Int,
    -- | month
    postIssuingCardholdersRequestBodyIndividual'Dob'Month :: GHC.Types.Int,
    -- | year
    postIssuingCardholdersRequestBodyIndividual'Dob'Year :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyIndividual'Dob' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["day" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Day obj] : ["month" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Month obj] : ["year" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Year obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["day" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Day obj] : ["month" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Month obj] : ["year" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodyIndividual'Dob'Year obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyIndividual'Dob' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyIndividual'Dob'" (\obj -> ((GHC.Base.pure PostIssuingCardholdersRequestBodyIndividual'Dob' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "year"))

-- | Create a new 'PostIssuingCardholdersRequestBodyIndividual'Dob'' with all required fields.
mkPostIssuingCardholdersRequestBodyIndividual'Dob' ::
  -- | 'postIssuingCardholdersRequestBodyIndividual'Dob'Day'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersRequestBodyIndividual'Dob'Month'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersRequestBodyIndividual'Dob'Year'
  GHC.Types.Int ->
  PostIssuingCardholdersRequestBodyIndividual'Dob'
mkPostIssuingCardholdersRequestBodyIndividual'Dob' postIssuingCardholdersRequestBodyIndividual'Dob'Day postIssuingCardholdersRequestBodyIndividual'Dob'Month postIssuingCardholdersRequestBodyIndividual'Dob'Year =
  PostIssuingCardholdersRequestBodyIndividual'Dob'
    { postIssuingCardholdersRequestBodyIndividual'Dob'Day = postIssuingCardholdersRequestBodyIndividual'Dob'Day,
      postIssuingCardholdersRequestBodyIndividual'Dob'Month = postIssuingCardholdersRequestBodyIndividual'Dob'Month,
      postIssuingCardholdersRequestBodyIndividual'Dob'Year = postIssuingCardholdersRequestBodyIndividual'Dob'Year
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.verification@ in the specification.
data PostIssuingCardholdersRequestBodyIndividual'Verification' = PostIssuingCardholdersRequestBodyIndividual'Verification'
  { -- | document
    postIssuingCardholdersRequestBodyIndividual'Verification'Document :: (GHC.Maybe.Maybe PostIssuingCardholdersRequestBodyIndividual'Verification'Document')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyIndividual'Verification' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("document" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("document" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyIndividual'Verification' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyIndividual'Verification'" (\obj -> GHC.Base.pure PostIssuingCardholdersRequestBodyIndividual'Verification' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "document"))

-- | Create a new 'PostIssuingCardholdersRequestBodyIndividual'Verification'' with all required fields.
mkPostIssuingCardholdersRequestBodyIndividual'Verification' :: PostIssuingCardholdersRequestBodyIndividual'Verification'
mkPostIssuingCardholdersRequestBodyIndividual'Verification' = PostIssuingCardholdersRequestBodyIndividual'Verification' {postIssuingCardholdersRequestBodyIndividual'Verification'Document = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.verification.properties.document@ in the specification.
data PostIssuingCardholdersRequestBodyIndividual'Verification'Document' = PostIssuingCardholdersRequestBodyIndividual'Verification'Document'
  { -- | back
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyIndividual'Verification'Document'Back :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | front
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersRequestBodyIndividual'Verification'Document'Front :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyIndividual'Verification'Document' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("back" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document'Back obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("front" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document'Front obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("back" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document'Back obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("front" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodyIndividual'Verification'Document'Front obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyIndividual'Verification'Document' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodyIndividual'Verification'Document'" (\obj -> (GHC.Base.pure PostIssuingCardholdersRequestBodyIndividual'Verification'Document' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "back")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "front"))

-- | Create a new 'PostIssuingCardholdersRequestBodyIndividual'Verification'Document'' with all required fields.
mkPostIssuingCardholdersRequestBodyIndividual'Verification'Document' :: PostIssuingCardholdersRequestBodyIndividual'Verification'Document'
mkPostIssuingCardholdersRequestBodyIndividual'Verification'Document' =
  PostIssuingCardholdersRequestBodyIndividual'Verification'Document'
    { postIssuingCardholdersRequestBodyIndividual'Verification'Document'Back = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodyIndividual'Verification'Document'Front = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls@ in the specification.
--
-- Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
data PostIssuingCardholdersRequestBodySpendingControls' = PostIssuingCardholdersRequestBodySpendingControls'
  { -- | allowed_categories
    postIssuingCardholdersRequestBodySpendingControls'AllowedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'])),
    -- | blocked_categories
    postIssuingCardholdersRequestBodySpendingControls'BlockedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'])),
    -- | spending_limits
    postIssuingCardholdersRequestBodySpendingControls'SpendingLimits :: (GHC.Maybe.Maybe ([PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'])),
    -- | spending_limits_currency
    postIssuingCardholdersRequestBodySpendingControls'SpendingLimitsCurrency :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'AllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'BlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimits obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits_currency" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimitsCurrency obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'AllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'BlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimits obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits_currency" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimitsCurrency obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodySpendingControls'" (\obj -> (((GHC.Base.pure PostIssuingCardholdersRequestBodySpendingControls' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_limits")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_limits_currency"))

-- | Create a new 'PostIssuingCardholdersRequestBodySpendingControls'' with all required fields.
mkPostIssuingCardholdersRequestBodySpendingControls' :: PostIssuingCardholdersRequestBodySpendingControls'
mkPostIssuingCardholdersRequestBodySpendingControls' =
  PostIssuingCardholdersRequestBodySpendingControls'
    { postIssuingCardholdersRequestBodySpendingControls'AllowedCategories = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodySpendingControls'BlockedCategories = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodySpendingControls'SpendingLimits = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodySpendingControls'SpendingLimitsCurrency = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.allowed_categories.items@ in the specification.
data PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories' where
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodySpendingControls'AllowedCategories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.blocked_categories.items@ in the specification.
data PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories' where
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodySpendingControls'BlockedCategories'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items@ in the specification.
data PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' = PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'
  { -- | amount
    postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount :: GHC.Types.Int,
    -- | categories
    postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'])),
    -- | interval
    postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval :: PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories obj) : ["interval" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories obj) : ["interval" Data.Aeson.Types.ToJSON..= postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'" (\obj -> ((GHC.Base.pure PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval"))

-- | Create a new 'PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'' with all required fields.
mkPostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' ::
  -- | 'postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'
  PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval' ->
  PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'
mkPostIssuingCardholdersRequestBodySpendingControls'SpendingLimits' postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval =
  PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'
    { postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount = postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Amount,
      postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories = GHC.Maybe.Nothing,
      postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval = postIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.categories.items@ in the specification.
data PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories' where
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Categories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.interval@ in the specification.
data PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"all_time"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
  | -- | Represents the JSON value @"daily"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
  | -- | Represents the JSON value @"monthly"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
  | -- | Represents the JSON value @"per_authorization"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
  | -- | Represents the JSON value @"weekly"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
  | -- | Represents the JSON value @"yearly"@
    PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval' where
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime) = "all_time"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily) = "daily"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly) = "monthly"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization) = "per_authorization"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly) = "weekly"
  toJSON (PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly) = "yearly"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "all_time" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
            | val GHC.Classes.== "daily" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
            | val GHC.Classes.== "monthly" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
            | val GHC.Classes.== "per_authorization" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
            | val GHC.Classes.== "weekly" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
            | val GHC.Classes.== "yearly" -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodySpendingControls'SpendingLimits'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.status@ in the specification.
--
-- Specifies whether to permit authorizations on this cardholder\'s cards. Defaults to \`active\`.
data PostIssuingCardholdersRequestBodyStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodyStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodyStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    PostIssuingCardholdersRequestBodyStatus'EnumActive
  | -- | Represents the JSON value @"inactive"@
    PostIssuingCardholdersRequestBodyStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyStatus' where
  toJSON (PostIssuingCardholdersRequestBodyStatus'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodyStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodyStatus'EnumActive) = "active"
  toJSON (PostIssuingCardholdersRequestBodyStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> PostIssuingCardholdersRequestBodyStatus'EnumActive
            | val GHC.Classes.== "inactive" -> PostIssuingCardholdersRequestBodyStatus'EnumInactive
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodyStatus'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.type@ in the specification.
--
-- One of \`individual\` or \`company\`.
data PostIssuingCardholdersRequestBodyType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersRequestBodyType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersRequestBodyType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"company"@
    PostIssuingCardholdersRequestBodyType'EnumCompany
  | -- | Represents the JSON value @"individual"@
    PostIssuingCardholdersRequestBodyType'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersRequestBodyType' where
  toJSON (PostIssuingCardholdersRequestBodyType'Other val) = val
  toJSON (PostIssuingCardholdersRequestBodyType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersRequestBodyType'EnumCompany) = "company"
  toJSON (PostIssuingCardholdersRequestBodyType'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersRequestBodyType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "company" -> PostIssuingCardholdersRequestBodyType'EnumCompany
            | val GHC.Classes.== "individual" -> PostIssuingCardholdersRequestBodyType'EnumIndividual
            | GHC.Base.otherwise -> PostIssuingCardholdersRequestBodyType'Other val
      )

-- | Represents a response of the operation 'postIssuingCardholders'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostIssuingCardholdersResponseError' is used.
data PostIssuingCardholdersResponse
  = -- | Means either no matching case available or a parse error
    PostIssuingCardholdersResponseError GHC.Base.String
  | -- | Successful response.
    PostIssuingCardholdersResponse200 Issuing'cardholder
  | -- | Error response.
    PostIssuingCardholdersResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
